<script src="https://d3js.org/d3.v4.min.js"></script>
<script>
var nodes = [];
<%for (var i=0; i < nodes.length; ++i){%>
    nodes.push({
        id : "<%=nodes[i].id_ext%>",
        id_parent: "<%=nodes[i].id_parent_ext%>",
        name: "<%=nodes[i].node_name%>"
    });
<%}%>
var svg = d3.select("svg"),
    width = +svg.attr("width"),
    height = +svg.attr("height"),
    g = svg.append("g").attr("transform", "translate(40,0)");

var tree = d3.tree()
    .size([height, width - 160]);

var stratify = d3.stratify()
    .id(function(d) { return d.id; })
    .parentId(function(d) { return d.id_parent; });

var f = function(data) {

  var root = stratify(data)
            .sort(function(a, b) { return (a.height - b.height) || a.id.localeCompare(b.id); });

  var link = g.selectAll(".link")
    .data(tree(root).descendants().slice(1))
    .enter().append("path")
      .attr("class", "link")
      .attr("d", function(d) {
        return "M" + d.y + "," + d.x
            + "C" + (d.y + d.parent.y) / 2 + "," + d.x
            + " " + (d.y + d.parent.y) / 2 + "," + d.parent.x
            + " " + d.parent.y + "," + d.parent.x;
      });

  var node = g.selectAll(".node")
    .data(root.descendants())
    .enter().append("g")
      .attr("class", function(d) { return "node" + (d.children ? " node--internal" : " node--leaf"); })
      .attr("transform", function(d) { return "translate(" + d.y + "," + d.x + ")"; })

  node.append("circle")
      .attr("r", 2.5);

  node.append("text")
      .attr("dy", 3)
      .attr("x", function(d) { return d.children ? -8 : 8; })
      .style("text-anchor", function(d) { return d.children ? "end" : "start"; })
      .text(function(d) {  return d.data.name; });
};
f(nodes);

</script>